@echo off
setlocal enabledelayedexpansion

setlocal
call :setESC

:: Set the directory and URL pattern
set TARGET_DIR=C:\ProgramData\GOG.com\Galaxy\webcache
set URL_BASE=https://images.gog.com

:: Counter for replaced and deleted files
set REPLACED_COUNT=0
set DELETED_COUNT=0

SET CURL_FLAGS=

echo %ESC%[93mREPAIR GOG GALAXY IMAGES%ESC%[0m
echo Searching and replacing broken images in %TARGET_DIR%...

:: Iterate through 0KB .webp files
for /r "%TARGET_DIR%" %%i in (*.webp) do (
    set FILE_SIZE=%%~zi
    if !FILE_SIZE! equ 0 (
        :: Extract base file name without extension
        set BASE_NAME=%%~ni
        
        :: Construct the URL for .webp
        set WEBP_URL=!URL_BASE!/!BASE_NAME!.webp?namespace=gamesdb
        
        :: Display the download URL
        echo Downloading WEBP: !WEBP_URL!
        
        curl !CURL_FLAGS! -o "%%i" "!WEBP_URL!"

        :: If there's an SSL-related error and flags haven't been set yet, prompt the user
        if "!CURL_FLAGS!"=="" (
            if "%ERRORLEVEL%"=="35" set SSLERROR=YES
            if "%ERRORLEVEL%"=="51" set SSLERROR=YES
            if "%ERRORLEVEL%"=="60" set SSLERROR=YES
            if "%ERRORLEVEL%"=="77" set SSLERROR=YES
            if "%ERRORLEVEL%"=="84" set SSLERROR=YES

            if "%SSLERROR%"=="YES" (
                echo Error Level: %ERRORLEVEL%
                echo It seems there was an SSL certificate issue.
                echo Do you want to use an insecure method to fix this temporarily? ^(Y/N^)
                SET /P userChoice=
                if /I "%userChoice%"=="Y" SET CURL_FLAGS=-k
            )
            set SSLERROR=NO
        )

        :: Check if downloaded WEBP is still 0KB
        for %%s in (%%i) do set NEW_SIZE=%%~zs
        if !NEW_SIZE! equ 0 (
            :: Attempt downloading PNG and then JPG as alternatives
            set REPLACEMENT_FOUND=0
            for %%f in (png jpg) do (
                if !REPLACEMENT_FOUND! equ 0 (
                    set ALT_URL=!URL_BASE!/!BASE_NAME!.%%f?namespace=gamesdb
                    echo Trying alternative: !ALT_URL!
                    curl !CURL_FLAGS! -o "%%~dpni.%%f" "!ALT_URL!"
                    for %%a in (%%~dpni.%%f) do set ALT_SIZE=%%~za
                    if not !ALT_SIZE! equ 0 (
                        del "%%i"
                        ren "%%~dpni.%%f" "%%~ni.webp"
                        set /a REPLACED_COUNT+=1
                        set REPLACEMENT_FOUND=1
                    )
                )
            )
            if !REPLACEMENT_FOUND! equ 0 (
                del "%%i"
                set /a DELETED_COUNT+=1
            )
        )
    )
)

set "URL=donate.48design.com"
:: Display results
echo DONE.
echo.
echo Total replaced images: %REPLACED_COUNT%
echo Total deleted images: %DELETED_COUNT%
echo.
echo %ESC%[93mIt worked^^? Great^^! Happy gaming^^!%ESC%[0m
echo Say thank you with a small donation: %ESC%[92m %URL% %ESC%[0m
echo.
echo Would you like to open %URL%? (Y/N, default is Y)
set /p choice=

if /i "!choice!"=="N" (
    exit
) else (
    start "" "https://%URL%"
    exit
)
echo.

endlocal
pause

:: coloring workaround
:setESC
for /F %%a in ('"prompt $E$S & echo on & for %%b in (1) do rem"') do set "ESC=%%a"
exit /B
